package main

import (
	"fmt"
	"testing"

	"gorm.io/driver/postgres"
	"gorm.io/gorm"
)

func TestPG(t *testing.T) {
	host := "43.198.252.255"
	port := 8812
	user := "admin"
	password := "quest"
	database := "qdb"

	db, err := gorm.Open(postgres.Open(fmt.Sprintf("host=%s port=%d user=%s dbname=%s password=%s sslmode=disable", host, port, user, database, password)), &gorm.Config{})
	if err != nil {
		panic("failed to connect database")
	}

	// show tables

	querySQL := "SELECT " +
		"`TaskType`, `TaskId`, `TaskFinishTimestamp`, `TaskWorkload`, `TaskReqHash`, `TaskRespHash`, `TaskManagerSignature`, `TaskContainerSignature`, `TaskMinerSignature`, `TaskProfitAccount`, `TaskWorkerAccount` " +
		"FROM `proof` " +
		"WHERE `TaskFinishTimestamp` > ? AND `TaskFinishTimestamp` < ? " +
		"AND `TaskId` > ? " +
		"ORDER BY `TaskFinishTimestamp` DESC, `TaskId` DESC " +
		"LIMIT ?;"

	type Temp struct {
		TaskType               int
		TaskId                 string
		TaskFinishTimestamp    int
		TaskWorkload           int
		TaskReqHash            string
		TaskRespHash           string
		TaskManagerSignature   string
		TaskContainerSignature string
		TaskMinerSignature     string
		TaskProfitAccount      string
		TaskWorkerAccount      string
	}

	temp := &Temp{}

	err = db.Raw(querySQL, 1709610200, 1709610300, "", 5).Scan(&temp).Error
	// err = db.Debug().Raw(querySQL, 1709610200, 1709610300, 5).Scan(&temp).Error
	// err = db.Raw(querySQL, 5).Scan(&temp).Error
	t.Log(err)
	t.Log(temp)
}
